package pan_tadeusz;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Scanner;

public class PoliczKazdeSlowo2 {

	// W tej wersji: LinkedHashMap - kolejność słów jak w pliku
	// Inny sposób sprawdzania czy słowo występowało: spr czy nie null
	
	public static void main(String[] args) {
		try (Scanner scanner = new Scanner(new File("pan_tadeusz.txt"))) {
			scanner.useDelimiter("[^\\p{L}\\d]+");
			
			Map<String, Integer> mapa = new LinkedHashMap<>();
			while(scanner.hasNext()) {
				String slowo = scanner.next();
				Integer ileBylo = mapa.get(slowo);
				if(ileBylo == null) {
					ileBylo = 0;
				}
				mapa.put(slowo, ileBylo+1);
			}
			
			System.out.println("Unikalnych słów: " + mapa.size());

			for (Map.Entry<String, Integer> entry : mapa.entrySet()) {
				System.out.printf("%-15s → %4d razy\n", entry.getKey(), entry.getValue());
				
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

	}

}
