package pan_tadeusz;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

public class PoliczKazdeSlowo3 {

	// W tej wersji: TreeMap - kolejność słów wg kodów Unicode
	// operacja getOrDefault (od Java 8)
	
	public static void main(String[] args) {
		try (Scanner scanner = new Scanner(new File("pan_tadeusz.txt"))) {
			scanner.useDelimiter("[^\\p{L}\\d]+");
			
			System.out.println("Buduję mapę...");
			Map<String, Integer> mapa = new TreeMap<>();
			while(scanner.hasNext()) {
				String slowo = scanner.next();
				int ileBylo = mapa.getOrDefault(slowo, 0);
				mapa.put(slowo, ileBylo+1);
			}
			
			System.out.println("Unikalnych słów: " + mapa.size());

			for (Map.Entry<String, Integer> entry : mapa.entrySet()) {
				System.out.printf("%-15s → %4d razy\n", entry.getKey(), entry.getValue());
				
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

	}

}
