package pan_tadeusz;

import java.io.File;
import java.io.FileNotFoundException;
import java.text.Collator;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Scanner;
import java.util.TreeMap;

public class PoliczKazdeSlowo5b {

	public static void main(String[] args) {
		try (Scanner scanner = new Scanner(new File("pan_tadeusz.txt"))) {
			scanner.useDelimiter("[^\\p{L}\\d]+");
			
			System.out.println("Buduję mapę...");
			Map<String, Integer> mapa = new TreeMap<>(Collator.getInstance());
			while(scanner.hasNext()) {
				String slowo = scanner.next();
				int ileBylo = mapa.getOrDefault(slowo, 0);
				mapa.put(slowo, ileBylo+1);
			}
			
			System.out.println("Unikalnych słów: " + mapa.size());
			
			System.out.println("Sortuję dane...");
			List<Entry<String, Integer>> lista = new ArrayList<>(mapa.entrySet());
			Collections.sort(lista, new EntryComparator());
			
			for (Entry<String, Integer> entry : lista) {
				System.out.printf("%-15s → %4d razy\n", entry.getKey(), entry.getValue());
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

	}

}
