package pan_tadeusz;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

import javax.swing.JOptionPane;

public class SzukajSlowa_HashSet {
	
	static Set<String> wczytajSlowa(String sciezka) {
		Set<String> slowa = new HashSet<>();
		try (Scanner scanner = new Scanner(new File("pan_tadeusz.txt"))) {
			scanner.useDelimiter("[^\\p{L}\\d]+");
			while(scanner.hasNext()) {
				slowa.add(scanner.next());
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return slowa;
	}

	public static void main(String[] args) {
		long p, k;
		
		p = System.nanoTime();
		Set<String> slowa = wczytajSlowa("pan_tadeusz.txt");
		k = System.nanoTime();
		JOptionPane.showMessageDialog(null, String.format("Wczytano %d słów. Czas: %,d µs", slowa.size(), (k-p)/1000));
		
		while(true) {
			String szukaneSlowo = JOptionPane.showInputDialog("Jakiego słowa szukasz?");
			if(szukaneSlowo == null)
				break;
			p = System.nanoTime();
			boolean jest = slowa.contains(szukaneSlowo);
			k = System.nanoTime();
			if(jest) {
				JOptionPane.showMessageDialog(null, String.format("Słowo znalezione, czas: %,d µs", (k-p)/1000));
			} else {
				JOptionPane.showMessageDialog(null, String.format("Słowa nie ma, czas: %,d µs", (k-p)/1000));
			}
		}
	}

}
