package pan_tadeusz;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import javax.swing.JOptionPane;

public class SzukajSlowa_Lista3 {
	
	static List<String> wczytajSlowa(String sciezka) {
		List<String> slowa = new ArrayList<>();
		try (Scanner scanner = new Scanner(new File("pan_tadeusz.txt"))) {
			scanner.useDelimiter("[^\\p{L}\\d]+");
			while(scanner.hasNext()) {
				slowa.add(scanner.next());
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return slowa;
	}

	static int ileRazy(List<String> slowa, String szukaneSlowo) {
		int ileRazy = 0;
		for(String slowo : slowa) {
			if(slowo.equals(szukaneSlowo)) {
				ileRazy++;
			}
		}
		return ileRazy;
	}

	public static void main(String[] args) {
		long p, k;
		
		p = System.nanoTime();
		List<String> slowa = wczytajSlowa("pan_tadeusz.txt");
		k = System.nanoTime();
		JOptionPane.showMessageDialog(null, String.format("Wczytano %d słów. Czas: %,d µs", slowa.size(), (k-p)/1000));
		
		while(true) {
			String szukaneSlowo = JOptionPane.showInputDialog("Jakiego słowa szukasz?");
			if(szukaneSlowo == null)
				break;
			p = System.nanoTime();
			int ileRazy = ileRazy(slowa, szukaneSlowo);
			k = System.nanoTime();
			if(ileRazy >= 0) {
				JOptionPane.showMessageDialog(null, String.format("Słowo występuje %d razy, czas: %,d µs", ileRazy, (k-p)/1000));
			} else {
				JOptionPane.showMessageDialog(null, String.format("Słowa nie ma, czas: %,d µs", (k-p)/1000));
			}
		}
	}
}
