package pan_tadeusz;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

import javax.swing.JOptionPane;

public class SzukajSlowa_Mapa {

	static Map<String, Integer> wczytajSlowa(String sciezka) {
		Map<String, Integer> mapa = new HashMap<>();
		try (Scanner scanner = new Scanner(new File(sciezka))) {
			scanner.useDelimiter("[^\\p{L}\\d]+");
			while (scanner.hasNext()) {
				String slowo = scanner.next();
				int ileBylo = mapa.getOrDefault(slowo, 0);
				mapa.put(slowo, ileBylo + 1);
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return mapa;
	}

	public static void main(String[] args) {
		long p, k;

		p = System.nanoTime();
		Map<String, Integer> slowa = wczytajSlowa("pan_tadeusz.txt");
		k = System.nanoTime();
		JOptionPane.showMessageDialog(null,
				String.format("Wczytano %d słów. Czas: %,d µs", slowa.size(), (k - p) / 1000));

		while (true) {
			String szukaneSlowo = JOptionPane.showInputDialog("Jakiego słowa szukasz?");
			if (szukaneSlowo == null)
				break;
			p = System.nanoTime();
			Integer ileRazy = slowa.get(szukaneSlowo);
			k = System.nanoTime();
			if (ileRazy != null) {
				JOptionPane.showMessageDialog(null,
						String.format("Słowo występuje %d razy, czas: %,d µs", ileRazy, (k - p) / 1000));
			} else {
				JOptionPane.showMessageDialog(null, String.format("Słowa nie ma, czas: %,d µs", (k - p) / 1000));
			}
		}
	}
}
