package sprzedaz.wydajnosc;

import java.io.File;
import java.util.List;

import sprzedaz.MaszynaWczytujaca2;
import sprzedaz.Transakcja;

// Wydzielenie wczytywania do oddzielnej klasy MaszynaWczytujaca2.
// W tamtej klasie zamiast HashMap używany jest ConcurrentHashMap.
public class WczytajSprzedaz7 {
	public static void main(String[] args) {
		Pomiary.wypiszPamiec();
		Opakowanie<List<Transakcja>> wynik = Opakowanie.empty();

		System.out.println("\nczytam");
		File plik = new File(WyczarujPliki.DUZY_PLIK);

		Pomiary.zmierzCzasDzalania(() -> {
			try {
				List<Transakcja> lista = MaszynaWczytujaca2.wczytajCalyPlik(plik);
				wynik.set(lista); // aby GC nie usunął listy
				System.out.println("Wczytano " + lista.size());
			} catch (Exception e) {
				e.printStackTrace();
			}
		});
		Pomiary.wypiszPamiec();

		System.out.println("\ngc");
		System.gc();
		try {
			Thread.sleep(2000);
		} catch (InterruptedException e) {
		}
		Pomiary.wypiszPamiec();
		System.out.println(wynik.get().size());
	}

}
